#!/bin/bash -e

MB=1048576
MAX=1000
WARN=100
CRIT=100
if [ "$2" ]; then
  MAX=$2
fi
if [ "$4" ]; then
  WARN=$3
  CRIT=$4
fi

cd "/sys/class/net/$1/statistics"

for val in `ls -1 collisions rx_* tx_*`; do
  eval $val=`cat $val`
done

add() {
  rx="`eval echo \\$rx_$1`"
  rx=`dc -e "$rx $2 * p"`
  tx="`eval echo \\$tx_$1`"
  tx=`dc -e "$tx $2 * p"`
  name="`echo $1 | sed 's/byte/bit/'`"
  ret="$ret rx_$name=$rx$3 tx_$name=$tx$3"
}

ret="OK|collisions=${collisions}c;10;100"
WARN=`dc -e "$MB $MAX * $WARN * 100 / p"`
CRIT=`dc -e "$MB $MAX * $CRIT * 100 / p"`
MAX=`dc -e "$MB $MAX * p"`
add bytes 8 "c;$[$WARN];$[$CRIT];0;$[$MAX]"
add packets 1 "c"
add errors 1 "c;10;100"
add dropped 1 "c;10;100"
echo "$ret"

exit 0
